From 78c228772f40cc8cf2a8b88efb4782c40bd6af99 Mon Sep 17 00:00:00 2001
From: Cyril Brulebois <kibi@debian.org>
Date: Wed, 18 Mar 2020 18:44:55 +0100
Subject: [PATCH] attempt 2

---
 slaves/lint_po | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

diff --git a/slaves/lint_po b/slaves/lint_po
index af7bd35..57baab9 100755
--- a/slaves/lint_po
+++ b/slaves/lint_po
@@ -28,6 +28,7 @@ mypy lint_po
 
 import argparse
 import contextlib
+import copy
 import functools
 import glob
 import itertools
@@ -181,11 +182,15 @@ class PoFile:
            @returns a list of issues raised by i18nspector removes
                     allowed issues from @I18NINSPECTOR_ACCEPT.
         """
+
+        # Make sure to have a specific subdirectory:
+        my_env = copy.copy(i18nspector_env)
+        my_env["XDG_CACHE_HOME"] += "/{pid}".format(pid=os.getpid())
         cmd = ["i18nspector", "--language",
                self.lang_without_script(), self.fname]
         process = subprocess.run(
                 cmd,
-                env = i18nspector_env,
+                env = my_env,
                 stdout=subprocess.PIPE,
                 stderr=subprocess.PIPE,
                 universal_newlines=True,
@@ -316,6 +321,9 @@ def main(logger) -> None:
         # check only the headers
         pool = multiprocessing.Pool()
         with tempfile.TemporaryDirectory() as tmpXDGCacheHome:
+            # A per-child subdirectory will actually be used, to avoid
+            # race conditions between those populating the cache, and
+            # those who aren't (#17359#note-24 and following):
             i18nspector_env = {"XDG_CACHE_HOME": tmpXDGCacheHome}
             _check_po_file = functools.partial(check_po_file,
                                                extended=args.extended,
-- 
2.11.0

